/*
 * telnet_server.h
 *
 *  Created on: 24.11.2017
 *      Author: balbekova
 */

#ifndef TELNET_SERVER_H_
#define TELNET_SERVER_H_

#include "settings_api.h"

/* Dimensions the buffer into which input characters are placed. */
#define cmdMAX_INPUT_SIZE			144

/*Number of connection*/
#define NUMBER_TELNET_CONNECT		5

typedef enum{
	TELNET_AUTH = 0,
	TELNET_AUTH_PASSW,
	TELNET_CMD,
	TELNET_CHANGE_PWD,
	TELNET_CHANGE_PWD_ACK
}state_telnet_server_t;

/**
 * A telnet connection structure.
 */
typedef struct{
	uint8_t state;
	uint8_t code;
	char buf[cmdMAX_INPUT_SIZE];
	char bufptr;
	char prev_cmd[cmdMAX_INPUT_SIZE];
	unsigned char optdata[cmdMAX_INPUT_SIZE];
	uint8_t optlen;
	state_telnet_server_t telnetState;
	user_level_t telnet_code_auth;
	char login[MAX_WEB_LOGIN_LEN];
	uint8_t login_err;
	uint8_t num_connect;
	bool active_conn;
	bool flagWhiteListTelnet;
}telnetd_state_t;


void telnet_server_init(void);

void telnet_server_close(void);

void telnet_server_port_change(void);

#endif /* TELNET_SERVER_H_ */
